<?php

namespace Drupal\taxonomy_proportion\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Plugin\Field\FieldFormatter\EntityReferenceLabelFormatter;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\Attribute\FieldFormatter;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Plugin implementation of the 'taxonomy_proportion' formatter.
 */
#[FieldFormatter(
  id: 'taxonomy_proportion_formatter',
  label: new TranslatableMarkup('Taxonomy proportion formatter'),
  description: new TranslatableMarkup('A formatter for Taxonomy proportion'),
  field_types: ['taxonomy_proportion'],
)]
class TaxonomyProportionFormatter extends EntityReferenceLabelFormatter {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = parent::viewElements($items, $langcode);

    foreach ($elements as $delta => &$element) {
      $element['proportion'] = [
        '#type' => 'html_tag',
        '#tag' => 'span',
        '#value' => $this->t(': @proportion%', [
          '@proportion' => $items[$delta]->proportion,
        ]),
      ];
    }

    return $elements;
  }
}